import { aws_ec2, aws_iam, Resource, Tag } from 'aws-cdk-lib';
import { IInstance } from 'aws-cdk-lib/aws-ec2';
import { Construct } from 'constructs';
export interface WindowsBastionProps {
    readonly securityTag?: Tag;
    readonly createKeyPair?: boolean;
    readonly vpc: aws_ec2.IVpc;
    readonly windowsPackages?: string[];
    readonly vpcSubnets: aws_ec2.SubnetSelection;
}
export declare class WindowsBastion extends Resource implements IInstance {
    readonly securityGroup: aws_ec2.ISecurityGroup;
    readonly instanceId: string;
    readonly instanceAvailabilityZone: string;
    readonly instancePrivateDnsName: string;
    readonly instancePrivateIp: string;
    readonly instancePublicDnsName: string;
    readonly instancePublicIp: string;
    readonly connections: aws_ec2.Connections;
    readonly grantPrincipal: aws_iam.IPrincipal;
    constructor(scope: Construct, id: string, props: WindowsBastionProps);
}
